int pbIn = 0;                  // Interrupt 0 is on DIGITAL PIN 2!
int ledOut = 13;                // The output LED pin
int inByte = 0;         // incoming serial byte
volatile int state = LOW;      // The input state toggle

long debouncing_time = 250; //Debouncing Time in Milliseconds
volatile unsigned long last_micros;

volatile unsigned long last_micros_footDown;

String data_log_string;
int data_logger[512];
int data_logger_index = 0;

void setup()
{                
  // Set up the digital pin 2 to an Interrupt and Pin 13 to an Output
  pinMode(ledOut, OUTPUT);

  //Attach the interrupt to the input pin and monitor for ANY Change 
  attachInterrupt(pbIn, debounceInterrupt, FALLING);
  
  //Debug
  Serial.begin(9600);
}

void loop()                     
{
  inByte = 0;
  // if we get a valid byte:
  if (Serial.available() > 0) 
  {
    // get incoming byte:
    inByte = Serial.read();
  }
  
  if (inByte == 82)
  {
    // Print the data log
    for (int i = 0; i< 512; i++)
    {
      Serial.println(data_logger[i]);
    }
  }
    
}// end void loop

void debounceInterrupt() 
{
  if((long)(micros() - last_micros) >= debouncing_time * 1000)
   {
    footDown();
    last_micros = micros();
   }
}


void footDown()
{
  unsigned int delta_time_int;
  unsigned long delta_time;
  char a;
  char b;
  state = !state;
  digitalWrite(ledOut, state);
  //Serial.println("Foot has touched ground");
  // We need to know the time since the last time this function was called
  delta_time = (micros() - last_micros_footDown) / 1000;
  delta_time_int = int(delta_time);
  // Put this data into our logger string
  //a = (char) highByte(delta_time_int);
  //b = (char) lowByte(delta_time_int);
  //data_log_string = data_log_string + String(a);
  //data_log_string = data_log_string + String(b);
  data_logger[data_logger_index] = delta_time_int;
  data_logger_index++;
  // wrap around the data_logger_index
  if (data_logger_index > 511)
  {
    data_logger_index = 0;
  }  
  last_micros_footDown = micros();
  //Serial.println(delta_time_int);  
}

